Subject: RE: 2 questions on the VRRP spec.

From: Mike Shand <[email-masked]>
Date: Tue, 7 Apr 1998 14:41:24 +0100

On Tuesday, April 07, 1998 2:23 PM, Carol Iturralde [SMTP:[email-masked]] 
wrote:
> I understand that Advertisements must be send using
> 00-00-5E-00-01-{VRID} as the source MAC address.
>
> My questions are:
>
>   - when sending an ARP reply (when the request was for a
>     IP address of a virtual router), must this reply be sent
>     using 00-00-5E-00-01-{VRID} as the source MAC address?
>     (I understand that this MAC address must be present in
>     the ARP packet, but I am asking about the datalink header'
>     source MAC address).

No. There's no requirement to do so. Of course it wouldn't hurt. There is a 
requirement to use the ****{VRID} MAC address in at least the VRRP messages 
themselves in order to cause learning bridges to correctly learn the location, 
especially when they move. Using this MAC address for other packets would only 
help speed up this process, but note that it could be disaterous to use the 
WRONG ****{VRID} MAC address
>
>     I don't recall seeing this spelled out in the spec.
>
>   - when a vrrp-router forwards a data packet which it received
>     (with MAC DA == 00-00-5E-00-01-{VRID1}), and the outgoing
>     interface it uses to forward the packet is also one on
>     which it is acting as a virtual router, is it required
>     to use 00-00-5E-00-01-{VRID2} as the source MAC address
>     of the outbound packet?

No.
>
>     Again, I don't recall seeing this spelled out in the spec.
>
> The reason these questions are important is that it is fairly
> easy to implement the insertion of the special MAC address
> in ARP code, and also when sending Advertisements.  The other
> two cases (above) are more complicated, and I don't want
> to do them if they are not required.
>
> Please advise.

---

From: Acee Lindem <[email-masked]>
Date: Wed, 15 Apr 1998 19:20:11 -0400

> >     the ARP packet, but I am asking about the datalink header'

With source route bridging, it is preferable to use the virtual MAC address
as the MAC source address in the ARP reply. The reason for this is that some
token ring device driver implementations keep a cache of MAC address to RIF 
mappings independent of the ARP cache. Hence, if the host never receives 
a unicast packet with the virtual MAC address as the source MAC, it will 
never be able to resolve the RIF for the virtual MAC address. For host 
implementations that keep the RIF in the ARP entry (e.g., IBM AIX), this is 
not a problem. 

Note that the RIF (Route Information Field) is a variable length field
in the MAC header of source route bridged packets which contains the 
complete source-route bridge path to the destination MAC. It consists
of a 2 byte routing control header and 1-8 ring number/bridge number
tuples.

A way to get around this is to use the functional address virtual MAC mapping 
for source route bridged LANs (i.e., token ring). A disadvantage of this is
that packets addressed to the token ring functional address traverse all the
LAN segments.

-- 
Acee